/// <reference types="react" />
import { Field } from '../field/field.component';
import { ICronFieldProps } from '../../../definition';
/**
 * @component-impl
 * @stable [28.12.2020]
 */
export declare class CronField extends Field<ICronFieldProps> {
    /**
     * @stable [28.12.2020]
     */
    static readonly defaultProps: ICronFieldProps & Partial<import("../../../definition").IGenericComponentProps<any>>;
    /**
     * @stable [28.12.2020]
     */
    private static readonly DEFAULT_VALUES_FACTORIES;
    /**
     * @stable [28.12.2020]
     * @param originalProps
     */
    constructor(originalProps: ICronFieldProps);
    /**
     * @stable [28.12.2020]
     * @param value
     * @protected
     */
    protected isValueDefined(value: string): boolean;
    /**
     * @stable [15.12.2019]
     * @returns {string}
     */
    protected get defaultValue(): string;
    /**
     * @stable [28.12.2020]
     * @protected
     */
    protected get inputAttachmentElement(): JSX.Element;
    /**
     * @stable [28.12.2020]
     * @protected
     */
    protected getFieldClassName(): string;
    /**
     * @stable [28.12.2020]
     * @param calendarDayEntity
     * @private
     */
    private onDaySelect;
    /**
     * @stable [28.12.2020]
     * @private
     */
    private get returnNeverExecutablePeriodAsEmptyValue();
    /**
     * @stable [28.12.2020]
     * @param entity
     * @param day
     * @private
     */
    private isDaySelected;
    /**
     * @stable [28.12.2020]
     * @param weekDayEntity
     * @private
     */
    private getCalendarCellElement;
    /**
     * @stable [28.12.2020]
     * @private
     */
    private get calendarEntity();
    /**
     * @stable [28.12.2020]
     * @private
     */
    private get days();
    /**
     * @stable [28.12.2020]
     * @private
     */
    private get newCronEntity();
    /**
     * @stable [28.12.2020]
     * @private
     */
    private get isoWeek();
}
