import { StoreProxy } from '../store.proxy';
import { IDictionaryStoreProxy, IFluxEntity, IGenericContainer, IGenericContainerProps, IReduxStoreEntity } from '../../../../definition';
export declare class DictionaryStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements IDictionaryStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [07.08.2020]
     * @param dictionary
     * @param fluxEntity
     */
    dispatchLoadDictionaryOnChange<TData = {}>(dictionary: string, fluxEntity?: IFluxEntity<TData>): void;
    /**
     * @stable [07.08.2020]
     * @param dictionary
     * @param fluxEntity
     * @private
     */
    private dispatchLoadDictionary;
}
