/// <reference types="react" />
import { IPdfViewerProps, IViewerProps } from '../../../definition';
import { Viewer } from '../viewer.component';
export declare class PdfViewer extends Viewer {
    static readonly defaultProps: IViewerProps & Partial<import("../../../definition").IGenericComponentProps<any>>;
    private pdfRendererPlugin;
    private readonly canvasRef;
    /**
     * @stable [16.03.2020]
     * @param {IPdfViewerProps} props
     */
    constructor(props: IPdfViewerProps);
    /**
     * @stable [16.03.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [16.03.2020]
     */
    protected refreshOnSrcChanges(): void;
    /**
     * @stable [16.03.2020]
     */
    protected refreshOnInternalChanges(): void;
    /**
     * @stable [14.12.2020]
     * @protected
     */
    protected get contentElement(): JSX.Element;
    /**
     * @stable [14.12.2020]
     * @protected
     */
    protected get previewElement(): JSX.Element;
    /**
     * @stable [13.12.2020]
     * @protected
     */
    protected get isPreviewForwardActionDisabled(): boolean;
    /**
     * @stable [23.03.2020]
     * @returns {number}
     */
    protected get defaultScale(): number;
}
