import { ITransportFactory, ITransportRequestEntity, ITransportResponseFactoryEntity } from '../../definition';
export declare class TransportFactory implements ITransportFactory {
    private readonly cancelUuid;
    private readonly operationsIdsMap;
    private readonly settings;
    private readonly requestPayloadFactory;
    private readonly requestProvider;
    private readonly responseFactory;
    /**
     * @stable [11.08.2019]
     * @param {ITransportRequestEntity} req
     * @param {(payload: ITransportRequestEntity) => ITransportRequestEntity} requestPayloadHandler
     * @returns {Promise<ITransportResponseFactoryEntity>}
     */
    request(req: ITransportRequestEntity, requestPayloadHandler?: (payload: ITransportRequestEntity) => ITransportRequestEntity): Promise<ITransportResponseFactoryEntity>;
    /**
     * @stable [24.12.2020]
     * @param req
     */
    cancelRequest(req: ITransportRequestEntity): void;
    /**
     * @stable [24.12.2020]
     * @param operationId
     * @private
     */
    private clearOperation;
    /**
     * @stable [24.12.2020]
     * @param req
     * @private
     */
    private getResponseFactory;
    /**
     * @stable [24.12.2020]
     * @param req
     * @private
     */
    private getRequestProvider;
    /**
     * @stable [24.12.2020]
     * @param req
     * @private
     */
    private asOperationId;
}
