import { IEntity, IEntityIdTWrapper, IKeyValue } from '../definitions.interface';
/**
 * @stable [19.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
export declare const arrayMinValue: (array: number[]) => number;
/**
 * @stable [22.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
export declare const arrayNextMinNegativeValue: (array: number[]) => number;
/**
 * @stable [13.12.2020]
 * @param array
 */
export declare const isArrayNotEmpty: <TValue>(array: TValue[]) => boolean;
/**
 * @stable [31.07.2020]
 */
export declare class ArrayUtils {
    static readonly doesArrayContainExistedEntity: <TEntity extends IEntity = IEntity>(data: TEntity[], entity: IEntityIdTWrapper, predicate?: <TEntity_1 extends IEntityIdTWrapper = IEntityIdTWrapper>(entity1: TEntity_1, entity2: TEntity_1) => boolean) => boolean;
    static readonly isArrayNotEmpty: <TValue>(array: TValue[]) => boolean;
    static readonly makeArray: <TValue = unknown>(length: number) => TValue[];
    static readonly mergeArrayItem: <TValue = IKeyValue>(array: TValue[], item: TValue, predicate?: <TEntity extends IEntityIdTWrapper = IEntityIdTWrapper>(entity1: TEntity, entity2: TEntity) => boolean, itemFactory?: ($item: TValue) => TValue) => TValue[];
    static readonly subArray: <TValue>(array: TValue[], limit?: number) => TValue[];
}
