"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoinUtils = void 0;
var array_1 = require("./array");
var filter_1 = require("./filter");
var nvl_1 = require("./nvl");
var definitions_interface_1 = require("../definitions.interface");
/**
 * @stable [13.12.2020]
 * @param parts
 * @param joiner
 */
var join = function (parts, joiner) {
    if (joiner === void 0) { joiner = definitions_interface_1.UniCodesEnum.SPACE; }
    return filter_1.FilterUtils.notNilValuesArrayFilter.apply(filter_1.FilterUtils, parts).join(joiner);
};
/**
 * @stable [13.12.2020]
 * @param parts
 */
var joinReduce = function (parts) {
    return array_1.ArrayUtils.isArrayNotEmpty(parts)
        ? (parts.length > 1
            ? parts[0] + ", ..."
            : nvl_1.NvlUtils.nvl(parts[0], ''))
        : '';
};
/**
 * @stable [13.12.2020]
 */
var JoinUtils = /** @class */ (function () {
    function JoinUtils() {
    }
    JoinUtils.join = join;
    JoinUtils.joinReduce = joinReduce;
    return JoinUtils;
}());
exports.JoinUtils = JoinUtils;
//# sourceMappingURL=join.js.map