import { AnyT } from '../definitions.interface';
/**
 * @stable [18.04.2020]
 * @param {AnyT} o
 * @returns {boolean}
 */
export declare const isObjectNotEmpty: <TValue>(o: AnyT) => boolean;
/**
 * @stable [18.03.2020]
 * @param {AnyT} o
 * @returns {boolean}
 */
export declare const isStringNotEmpty: <TValue>(o: AnyT) => boolean;
/**
 * @stable [15.05.2020]
 */
export declare class ObjectUtils {
    static readonly buildNotEmptyOrNullValuesObject: <TValue>(object: TValue) => Record<string | number, any>;
    static readonly buildTrueValuesObject: <TValue>(object: TValue) => Record<string | number, boolean>;
    static readonly buildUndefValuesObject: <TValue>(object: TValue) => Record<string | number, unknown>;
    static readonly buildValuesObjectBy: <TValue>(object: TValue, mergeFn?: (o: any, key: any) => any, keyAccessor?: (o: any, key: any) => any) => Record<string | number, any>;
    static readonly isCurrentValueNotEqualPreviousValue: (current: any, previous: any) => boolean;
    static readonly isObjectEmpty: <TValue>(o: unknown) => boolean;
    static readonly isObjectNotEmpty: <TValue>(o: any) => boolean;
}
